; Example: On-screen display (OSD) via transparent window:

CustomColor = 00FF00  ; Can be any RGB color (it will be made transparent below).
Gui +LastFound +AlwaysOnTop -Caption +ToolWindow +E0x20 ; +ToolWindow avoids a taskbar button and an alt-tab menu item.
Gui, Color, %CustomColor%

;  Change values/font below to fit your preferences

;PosX = 355                      ; default 355 (720p windowed)
;PosY = 40                       ; default 40 (720p windowed)
;Wi := 1065 + PosX               ; default 1065 + PosX (720p windowed)
;Hi := 366 + PosY                ; default 366 + PosY (720p windowed)
;Gui Font, s13 q3, Courier New   ; default Gui Font, s13 q3, Courier New (720p windowed)

PosX = 533                       ; default 533 (1080p windowed fullscreen)
   ; x position of GUI, left
PosY = 10                        ; default 10 (1080p windowed fullscreen)
   ; y position of GUI, top 
Wi := 1600 + PosX                ; default 1600 + PosX (1080p windowed fullscreen)
   ; width of GUI
Hi := 550 + PosY                 ; default 550 + PosY (1080p windowed fullscreen)
   ; height of GUI
Gui Font, s20 q3, Courier New    ; default Gui Font, s20 q3, Courier New (1080p windowed fullscreen)
;        size quality fontname

; ------------------------------------------------------------------------------
; Script begins

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

MyNumber = 1
AA = 0

; Write to the array:
ArrayCount = 0
Loop, Read, objectives.txt
    ; This loop retrieves each line from the file, one at a time.
{
    ArrayCount += 1  ; Keep track of how many items are in the array.
    Array%ArrayCount% := A_LoopReadLine  ; Store this line in the next array element.
}

FPos = "Left"
PosXp := PosX + 1
PosXn := PosX - 1
PosYp := PosY + 1
PosYn := PosY - 1

Gui Add, Text, vBlackTopLeft cBlack x%PosXn% y%PosYn% h%Hi% w%Wi% BackgroundTrans, %InText%
Gui Add, Text, vBlackTopRight cBlack x%PosXp% y%PosYn% h%Hi% w%Wi% BackgroundTrans, %InText%
Gui Add, Text, vBlackBottomLeft cBlack x%PosXn% y%PosYp% h%Hi% w%Wi% BackgroundTrans, %InText%
Gui Add, Text, vBlackBottomRight cBlack x%PosXp% y%PosYp% h%Hi% w%Wi% BackgroundTrans, %InText%

Gui Add, Text, vBlackTop cBlack x%PosX% y%PosYn% h%Hi% w%Wi% BackgroundTrans, %InText%
Gui Add, Text, vBlackBottom cBlack x%PosX% y%PosYp% h%Hi% w%Wi% BackgroundTrans, %InText%
Gui Add, Text, vBlackLeft cBlack x%PosXn% y%PosY% h%Hi% w%Wi% BackgroundTrans, %InText%
Gui Add, Text, vBlackRight cBlack x%PosXp% y%PosY% h%Hi% w%Wi% BackgroundTrans, %InText%

Gui Add, Text, vWhite cWhite x%PosX% y%PosY% h%Hi% w%Wi% BackgroundTrans, %InText%

Gui Show, x0 y0 w%Wi% h%Hi% NoActivate

; Make all pixels of this color transparent and make the text itself translucent (150):
WinSet, TransColor, %CustomColor% 200

UpdateOSD()

; ------------------------------------------------------------------------------

UpdateOSD()
{
   global	
	
   Temp := Array%MyNumber%

   Num2 := MyNumber + 1
   Temp2 := Array%Num2%

   Num3 := MyNumber + 2
   Temp3 := Array%Num3%

   Num4 := MyNumber + 3
   Temp4 := Array%Num4%

   Num5 := MyNumber + 4
   Temp5 := Array%Num5%

   TL2 := Temp "`n" Temp2 "`n" Temp3 "`n" Temp4 "`n" Temp5
   Add2ColorTextToGui(1, "Green", 0, 0, 1100, 130, "Left", "Black", "White", 16, "Normal", "Liberation Mono", TL2 )
   return
}


; X - Advance objectives one step, write to file
x::
    MyNumber += 1
    if (MyNumber > ArrayCount - 3 ) 
    {
       MyNumber := ArrayCount - 3
    }
   UpdateOSD()
return


; Z - Go back one step, write to file
z::
   MyNumber -= 1
   if (MyNumber < 1)
   {
      MyNumber = 1
   }
   UpdateOSD()
return

; ------------------------------------------------------------------------------

Add2ColorTextToGui(GuiNo, BackColor, PosX,PosY,Wi,Hi,FPos,OutColor,FColor,FSize,FStyle,FName,InText)
{
   global

   GuiControl, -Redraw, BlackTopLeft
   GuiControl, -Redraw, BlackTopRight
   GuiControl, -Redraw, BlackBottomLeft
   GuiControl, -Redraw, BlackBottomRight

   GuiControl, -Redraw, BlackTop
   GuiControl, -Redraw, BlackBottom
   GuiControl, -Redraw, BlackLeft
   GuiControl, -Redraw, BlackRight

   GuiControl, -Redraw, White

   GuiControl,, BlackTopLeft, %InText%
   GuiControl,, BlackTopRight, %InText%
   GuiControl,, BlackBottomLeft, %InText%
   GuiControl,, BlackBottomRight, %InText%

   GuiControl,, BlackTop, %InText%
   GuiControl,, BlackBottom, %InText%
   GuiControl,, BlackLeft, %InText%
   GuiControl,, BlackRight, %InText%

   GuiControl,, White, %InText%

   GuiControl, +Redraw, BlackTopLeft
   GuiControl, +Redraw, BlackTopRight
   GuiControl, +Redraw, BlackBottomLeft
   GuiControl, +Redraw, BlackBottomRight

   GuiControl, +Redraw, BlackTop
   GuiControl, +Redraw, BlackBottom
   GuiControl, +Redraw, BlackLeft
   GuiControl, +Redraw, BlackRight

   GuiControl, +Redraw, White
}
